;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
;+
; @file_comments
; donne la date en long
;
; @obsolete
;
; @param date {in}{required} une date du type yyyymmdd
;
; @keyword GRADS if  1 le year le 49 then year = 2000+year
;               if 50 le year le 99 then year = 1900+year
;
; @keyword _EXTRA used to pass your keywords
;
; @returns une date vairmer du type yyyymmdd
; si year est nulle ou egale a -1 ne change rien
;
; @examples
; IDL> res=vraidate(date)
; IDL> vraidate(980703)
; donne 19980703 qui est un long
;
; @history Sebastien Masson (smasson\@lodyc.jussieu.fr)
;   3/7/98
; remove automatic change from year 1 to 1901... Aug 2004
;
; @version $Id: vraidate.pro 134 2006-07-07 10:19:08Z navarro $
;
;-
;------------------------------------------------------------
;------------------------------------------------------------
;------------------------------------------------------------
function vraidate, date, GRADS = grads, _EXTRA = ex
;------------------------------------------------------------
;
  compile_opt idl2, strictarrsubs, obsolete
;
  IF NOT keyword_set(GRADS) THEN return, long(date)
;
  date = long(date)
  annee = date/10000
  return, date+19000000L*(annee GE 50 and date lt 1000000)+20000000L*(annee LT 50 and date lt 1000000)
;------------------------------------------------------------
end
